
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

import java.sql.*;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;

import java.util.Arrays;


import java.util.Formatter;
import java.util.Calendar;

//klasa opisuje rad klijenta------------------------------------------------------
class Klijent implements Runnable {

    private DatagramPacket paket;
    private DatagramSocket soket;
   
    public Klijent(DatagramSocket soket) {
        this.soket = soket;
    }
    
    public void run() {
       
        try {
            while (true) {
                byte[] bafer2 = banka.sifrovanje(prozor.zahtev, banka.kljuc);//sifrovanje unetog zahteva
                paket = new DatagramPacket(bafer2, bafer2.length, InetAddress.getLocalHost(), 18888);
                soket.send(paket);//slanje paketa 
                
                soket.receive(paket);//primanje paketa
                bafer2 = paket.getData();//korisnickicki podaci 
                bafer2=Arrays.copyOf(bafer2, 16);//mora da bude duzina 16 zbog desifrovanja
                banka.odgovor = banka.desifrovanje(bafer2,banka.kljuc);//desifrovanje
                
                Formatter fmt = new Formatter();//novi format
                Calendar cal = Calendar.getInstance();//novo vreme i datum
                fmt.format("%tc", cal);//kreiranje vremenskog formata
                prozor.textArea.insert(fmt+"\nStanje na računu "+prozor.zahtev+" je: \n"+banka.odgovor+" RSD\n", 0);//ispis primljenog podatka
                
                break;//prekid da ne bi se beskonacno izvrsavala petlja
            }
        } catch (Exception e) {
            System.err.println("Exception");
            e.printStackTrace();
        }   
    }
}
//klasa koja opisuje rad servera--------------------------------------------------
class Server implements Runnable {

    private DatagramPacket paket;
    private DatagramSocket soket;
    
    
    public Server(DatagramSocket soket) {
        this.soket = soket;
    }
    //metod za komunikaciju sa bazom podataka----------------------
    public static String DB(String broj) {
        try {
            Class.forName("com.mysql.jdbc.Driver");//povezivanje sa JDBC driver-om
        } catch (ClassNotFoundException e) {
        }
        Connection con = null;
        Statement stmt = null;
        ResultSet rs = null;
        String stanje = "";
        try {//na koju adresu, sa kojim  korisnickim imenom i sifrom se povezati
            con = DriverManager.getConnection("jdbc:mysql://localhost:3306/banka", "root", "gari");
        } catch (SQLException e) {
        }
        if (con == null) {//ako se nije povezao na bazu
        	stanje="nepoznato";
        	prozor.textArea.insert("Došlo je do greške prilikom povezivanja na bazu podataka, molimo pokušajte ponovo. \n",0);
        }
        
        try {
            stmt = con.createStatement();            
            rs = stmt.executeQuery("SELECT StanjeRacuna FROM racun WHERE BrojRacuna='" + broj + "'");//upit baze podataka
            if (rs.next()) {
                stanje = rs.getString("StanjeRacuna");
            }else {
            	if (stanje==""){//ako zahteva nema u bazi podataka
            		stanje="nepoznato";
            		prozor.textArea.insert("Ovo nije račun UDP-AES banke \n",0); 
            		}
            	}
        } catch (Exception e) {
        } finally {
            try {
                rs.close();
                stmt.close();
                con.close();
            } catch (SQLException ex) {
                System.err.println("SQLException");
            }
        }
        return (stanje);
        
        
    }
    //--------------------------------------------------------------
    public void run() {
        
        while (true) {
            byte[] bafer = new byte[1024];
            String zahtev = new String();
            String odgovor = new String();
            paket = new DatagramPacket(bafer, bafer.length);
            try {
                soket.receive(paket);//primanje paketa
                InetAddress IPAddress = paket.getAddress();//cuvanje adrese sa koje je paket poslat
                int port = paket.getPort(); //cuvanje broja porta sa koje je paket poslat 
                bafer = paket.getData();
                bafer=Arrays.copyOf(bafer, 16);//duzina podatka mora biti 16 zbog desifrovanja
                zahtev = banka.desifrovanje(bafer,banka.kljuc);
                
                odgovor = DB(zahtev);//za zahtev nadji odgovor u bazi podataka
                
                byte[] bafer2 = banka.sifrovanje(odgovor,banka.kljuc);
                paket = new DatagramPacket(bafer2, bafer2.length, IPAddress, port);
                soket.send(paket);//odgovor se salje na adresu sa koje je poslat zahtev
                
                soket.close();//zatvaranje soketa da bi bilo moguce ponovo poslati zahtev
                break;//prekid da ne bi se beskonacno izvrsavala petlja
            } catch (Exception e) {
                System.err.println("Exception");
                e.printStackTrace();
            } 
        }
    }
}
//-------------------------------------------------------------------------------------


public class banka {
	
static String odgovor = "";
static String kljuc = "vanjin diplomski";

    public static void main(String[] args) throws Exception {
    	
    }
    public static byte[] sifrovanje(String zaSif, String kljuc) throws Exception {
    	Cipher cipher = Cipher.getInstance("AES");//sifra za AES algoritam
    	SecretKeySpec key = new SecretKeySpec(kljuc.getBytes("UTF-8"), "AES");//tajni kljuc
    	cipher.init(Cipher.ENCRYPT_MODE, key);//inicijalizacija sifre za enkripciju
    	return cipher.doFinal(zaSif.getBytes("UTF-8"));//sifrovanje podatka
    }
     
    public static String desifrovanje(byte[] zaDesif, String kljuc) throws Exception{
    	Cipher cipher = Cipher.getInstance("AES");//sifra za AES algoritam
    	SecretKeySpec key = new SecretKeySpec(kljuc.getBytes("UTF-8"), "AES");//tajni kljuc
    	cipher.init(Cipher.DECRYPT_MODE, key);//inicijalizacija sifre za dekripciju
    	return new String(cipher.doFinal(zaDesif),"UTF-8");//desifrovanje podatka
    }

    

}